package com.example.calendar;

import java.util.Map;

import com.vaadin.terminal.PaintException;
import com.vaadin.terminal.PaintTarget;
import com.vaadin.ui.AbstractComponent;

/**
 * Server side component for the VCalendar widget.
 */
@com.vaadin.ui.ClientWidget(com.example.calendar.widgetset.client.ui.VCalendar.class)
public class Calendar extends AbstractComponent {

    private int mode = 0;

    @Override
    public void paintContent(PaintTarget target) throws PaintException {
        super.paintContent(target);

        // Paint any component specific content by setting attributes
        // These attributes can be read in updateFromUIDL in the widget.
        target.addAttribute("mode", mode);

        // TODO: Send calendar settings to client


        // TODO: Send calendar appintments to client

        // We could also set variables in which values can be returned
        // but declaring variables here is not required
    }

    /**
     * Receive and handle events and other variable changes from the client.
     *
     * {@inheritDoc}
     */
    @Override
    public void changeVariables(Object source, Map<String, Object> variables) {
        super.changeVariables(source, variables);

        // Variables set by the widget are returned in the "variables" map.
    }

}
